#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF
// LED_p^[pϐ
char State;

// 荞ݏ
void Timer0IntHandler(void) {
	// ^C}Zbg
	TimerIntClear(WTIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// rbg]
	State = ~State;
	// LEDON/OFFɂ
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
}

// LED̓_ŎXCb`Ő
void main(void) {
	// ҂ԗpϐ
	volatile unsigned long Loop;
	// wpϐiCӂ̎ݒ\Ȃ悤A^Ƃj
	float Cycle;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// LEDpIO|[gDAXCb`pɃ|[gBgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
	// Ch^C}W[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_WTIMER0);

	// PD0o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);

	// PB2, PB3̓^Cvɐݒ
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_2);
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_3);

	// ^C}̐ݒ
	// Ch^C}W[0Full-width(64bit)̎JE^Ŏgp
	TimerConfigure(WTIMER0_BASE, TIMER_CFG_PERIODIC);
	// ^C}̊荞݂Ԋuݒ
	TimerLoadSet64(WTIMER0_BASE, SysCtlClockGet());
	// 荞ݎɌĂяoi֐jw
	TimerIntRegister(WTIMER0_BASE, TIMER_A, Timer0IntHandler);
	// 荞݂
	IntEnable(INT_WTIMER0A);
	// ^CAEgŊ荞݂
	TimerIntEnable(WTIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// ^C}L
	TimerEnable(WTIMER0_BASE, TIMER_A);
	// LEDOFFɂ
	State = OFF;
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
	// 1 bi1Hzjɐݒ
	Cycle = 1;
	while (1) {
		// PSW1ꂽꍇ
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_2) == 0) {
			// 荞ݎ𔼕ɂB
			Cycle *= 2;
			TimerLoadSet64(WTIMER0_BASE, SysCtlClockGet() / Cycle);
			// ҂
			for (Loop = 0; Loop < 200000; Loop++)
				;
		}
		// PSW2ꂽꍇ
		else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_3) == 0) {
			// 荞ݎ2{ɂB
			Cycle /= 2;
			TimerLoadSet64(WTIMER0_BASE, SysCtlClockGet() / Cycle);
			// ҂
			for (Loop = 0; Loop < 200000; Loop++)
				;
		}
	}
}
